diff --git a/drupal7/sites/all/modules/media/tests/media_module_test.info b/drupal7/sites/all/modules/media/tests/media_module_test.info
new file mode 100644
index 00000000..6e5b5416
--- /dev/null
+++ b/drupal7/sites/all/modules/media/tests/media_module_test.info
@@ -0,0 +1,12 @@
+name = Media test
+description = Provides hooks for testing Media module functionality.
+package = Media
+core = 7.x
+hidden = TRUE
+
+; Information added by Drupal.org packaging script on 2014-10-04
+version = "7.x-2.0-alpha4"
+core = "7.x"
+project = "media"
+datestamp = "1412422430"
+
diff --git a/drupal7/sites/all/modules/media/tests/media_module_test.module b/drupal7/sites/all/modules/media/tests/media_module_test.module
new file mode 100644
index 00000000..d4add679
--- /dev/null
+++ b/drupal7/sites/all/modules/media/tests/media_module_test.module
@@ -0,0 +1,64 @@
+<?php
+
+/**
+ * @file
+ * Provides Media module pages for testing purposes.
+ */
+
+/**
+ * Implements hook_menu().
+ */
+function media_module_test_menu() {
+  $items = array();
+
+  $items['media/test'] = array(
+    'title' => 'Media test',
+    'page callback' => 'drupal_get_form',
+    'page arguments' => array('media_module_test_form'),
+    'access arguments' => array('view files'),
+  );
+
+  return $items;
+}
+
+/**
+ * Form constructor for testing a 'media' element.
+ *
+ * @see media_module_test_form_submit()
+ * @ingroup forms
+ */
+function media_module_test_form($form, &$form_state, $tree = TRUE, $extended = FALSE) {
+  $form['#tree'] = (bool) $tree;
+
+  $form['nested']['media'] = array(
+    '#type' => 'media',
+    '#title' => t('Media'),
+    '#extended' => (bool) $extended,
+    '#size' => 13,
+  );
+
+  $form['textfield'] = array(
+    '#type' => 'textfield',
+    '#title' => t('Type a value and ensure it stays'),
+  );
+
+  $form['submit'] = array(
+    '#type' => 'submit',
+    '#value' => t('Save'),
+  );
+
+  return $form;
+}
+
+/**
+ * Form submission handler for media_module_test_form().
+ */
+function media_module_test_form_submit($form, &$form_state) {
+  if ($form['#tree']) {
+    $fid = $form['nested']['media']['#extended'] ? $form_state['values']['nested']['media']['fid'] : $form_state['values']['nested']['media'];
+  }
+  else {
+    $fid = $form['nested']['media']['#extended'] ? $form_state['values']['media']['fid'] : $form_state['values']['media'];
+  }
+  drupal_set_message(t('The file id is %fid.', array('%fid' => $fid)));
+}
diff --git a/drupal7/sites/all/modules/media/views/media_default.view.inc b/drupal7/sites/all/modules/media/views/media_default.view.inc
index e66ed112..54074650 100644
--- a/drupal7/sites/all/modules/media/views/media_default.view.inc
+++ b/drupal7/sites/all/modules/media/views/media_default.view.inc
@@ -28,9 +28,9 @@ $handler->display->display_options['query']['options']['query_tags'] = array(
   0 => 'media_browser',
 );
 $handler->display->display_options['exposed_form']['type'] = 'basic';
-$handler->display->display_options['exposed_form']['options']['autosubmit'] = TRUE;
+$handler->display->display_options['exposed_form']['options']['reset_button'] = FALSE;
 $handler->display->display_options['pager']['type'] = 'full';
-$handler->display->display_options['pager']['options']['items_per_page'] = '10';
+$handler->display->display_options['pager']['options']['items_per_page'] = '25';
 $handler->display->display_options['pager']['options']['offset'] = '0';
 $handler->display->display_options['pager']['options']['id'] = '0';
 $handler->display->display_options['style_plugin'] = 'media_browser';
@@ -39,7 +39,7 @@ $handler->display->display_options['empty']['area']['id'] = 'area';
 $handler->display->display_options['empty']['area']['table'] = 'views';
 $handler->display->display_options['empty']['area']['field'] = 'area';
 $handler->display->display_options['empty']['area']['content'] = 'No files available.';
-$handler->display->display_options['empty']['area']['format'] = 'plain_text';
+$handler->display->display_options['empty']['area']['format'] = filter_fallback_format();
 /* Field: File: Name */
 $handler->display->display_options['fields']['filename']['id'] = 'filename';
 $handler->display->display_options['fields']['filename']['table'] = 'file_managed';
diff --git a/drupal7/sites/all/modules/webform/components/date.inc b/drupal7/sites/all/modules/webform/components/date.inc
index 7a0a8b88..07a1322c 100644
--- a/drupal7/sites/all/modules/webform/components/date.inc
+++ b/drupal7/sites/all/modules/webform/components/date.inc
@@ -166,6 +166,10 @@ function webform_expand_date($element) {
     $timestring = webform_strtodate('c', $element['#default_value'], $timezone);
     $element['#default_value'] = webform_date_array($timestring, 'date');
   }
+  // Prevent an error in PHP 5.4 caused by core's treatment of the #value.
+  if (isset($element['#value'])) {
+    unset($element['#value']);
+  }
 
   // Set defaults according to existing #default_value (set by Form API)
   if (isset($element['#default_value']['month']) || isset($element['#default_value']['day']) || isset($element['#default_value']['year'])) {
diff --git a/drupal7/sites/all/modules/webform/components/fieldset.inc b/drupal7/sites/all/modules/webform/components/fieldset.inc
index eddc3b90..63ad33a1 100644
--- a/drupal7/sites/all/modules/webform/components/fieldset.inc
+++ b/drupal7/sites/all/modules/webform/components/fieldset.inc
@@ -74,7 +74,7 @@ function _webform_render_fieldset($component, $value = NULL, $filter = TRUE) {
  * Pre-render function to set a fieldset ID.
  */
 function webform_fieldset_prerender($element) {
-  $element['#id'] = drupal_html_id('webform-component-' . str_replace('_', '-', implode('--', array_slice($element['#parents'], 1))));
+  $element['#id'] = 'webform-component-' . str_replace('_', '-', implode('--', array_slice($element['#parents'], 1)));
   return $element;
 }
 
diff --git a/drupal7/sites/all/modules/webform/components/file.inc b/drupal7/sites/all/modules/webform/components/file.inc
index 7f46e1ce..561c0754 100644
--- a/drupal7/sites/all/modules/webform/components/file.inc
+++ b/drupal7/sites/all/modules/webform/components/file.inc
@@ -212,7 +212,7 @@ function _webform_edit_file_check_directory($element) {
   $scheme = $element['extra']['scheme']['#value'];
   $directory = $element['extra']['directory']['#value'];
 
-  $destination_dir = file_stream_wrapper_uri_normalize($scheme . '://' . $directory . '/webform');
+  $destination_dir = file_stream_wrapper_uri_normalize($scheme . '://webform/' . $directory);
 
   // Sanity check input to prevent use parent (../) directories.
   if (preg_match('/\.\.[\/\\\]/', $destination_dir . '/')) {
diff --git a/drupal7/sites/all/modules/webform/components/markup.inc b/drupal7/sites/all/modules/webform/components/markup.inc
index 9bb628b6..100a8602 100644
--- a/drupal7/sites/all/modules/webform/components/markup.inc
+++ b/drupal7/sites/all/modules/webform/components/markup.inc
@@ -66,9 +66,6 @@ function _webform_render_markup($component, $value = NULL, $filter = TRUE) {
     '#translatable' => array('title', 'markup'),
   );
 
-  // TODO: Remove when #markup becomes available in D7.
-  $element['#value'] = $element['#markup'];
-
   return $element;
 }
 
diff --git a/drupal7/sites/all/modules/webform/components/number.inc b/drupal7/sites/all/modules/webform/components/number.inc
index 6b0391bb..16152f11 100644
--- a/drupal7/sites/all/modules/webform/components/number.inc
+++ b/drupal7/sites/all/modules/webform/components/number.inc
@@ -276,9 +276,17 @@ function _webform_render_number($component, $value = NULL, $filter = TRUE) {
     '#max' => $component['extra']['max'],
     '#step' => $component['extra']['step'] ? abs($component['extra']['step']) : '',
     '#integer' => $component['extra']['integer'],
-    '#translatable' => array('title', 'description'),
+    '#point' => $component['extra']['point'],
+    '#separator' => $component['extra']['separator'],
+    '#decimals' => $component['extra']['decimals'],
+    '#translatable' => array('title', 'description', 'field_prefix', 'field_suffix'),
   );
 
+  // Set the decimal count to zero for integers.
+  if ($element['#integer'] && $element['#decimals'] === '') {
+    $element['#decimals'] = 0;
+  }
+
   // Flip the min and max properties to make min less than max if needed.
   if ($element['#min'] !== '' && $element['#max'] !== '' && $element['#min'] > $element['#max']) {
     $max = $element['#min'];
@@ -318,7 +326,15 @@ function _webform_render_number($component, $value = NULL, $filter = TRUE) {
 
   // Set user-entered values.
   if (isset($value[0])) {
-    $element['#default_value'] = $value[0];
+    // If the value has been standardized, convert it to the expected format
+    // for display to the user.
+    if (webform_number_format_match($value[0], '.', '')) {
+      $element['#default_value'] = _webform_number_format($component, $value[0]);
+    }
+    // Otherwise use the user-defined input.
+    else {
+      $element['#default_value'] = $value[0];
+    }
   }
 
   // Enforce uniqueness.
@@ -385,28 +401,17 @@ function _webform_analysis_number($component, $sids = array(), $single = FALSE)
 
   $population = array();
   $submissions = 0;
-  $nonzero = 0;
-  $not_empty = 0;
+  $non_zero = 0;
+  $non_empty = 0;
   $sum = 0;
 
   $result = $query->execute();
   foreach ($result as $data) {
     $value = trim($data['data']);
-    if ($value == '') {
-      $number = 0.0;
-    }
-    else {
-      $number = $value * 1.0;
-    }
-
-    if ($value !== '') {
-      $not_empty++;
-    }
-
-    if ($number > 0) {
-      $nonzero++;
-      $sum += $number;
-    }
+    $number = (float)$value;
+    $non_empty += (integer)($value !== '');
+    $non_zero += (integer)($number != 0.0);
+    $sum += $number;
     $population[] = $number;
     $submissions++;
   }
@@ -414,10 +419,10 @@ function _webform_analysis_number($component, $sids = array(), $single = FALSE)
 
   // Average and population count.
   if ($component['extra']['excludezero']) {
-    $average = $nonzero ? ($sum / $nonzero) : 0;
+    $average = $non_zero ? ($sum / $non_zero) : 0;
     $average_title = t('Average !mu excluding zeros/blanks', array('!mu' => $advanced_stats ? '(&mu;)' : ''));
     // Sample (sub-set of total population).
-    $population_count = $nonzero - 1;
+    $population_count = $non_zero - 1;
     $sigma = 'sd';
     $description = t('sample');
   }
@@ -434,8 +439,8 @@ function _webform_analysis_number($component, $sids = array(), $single = FALSE)
   $average = _webform_number_format($component, $average);
   $sum = _webform_number_format($component, $sum);
 
-  $rows[0] = array(t('Zero/blank'), ($submissions - $nonzero));
-  $rows[1] = array(t('User entered value'), $not_empty);
+  $rows[0] = array(t('Zero/blank'), ($submissions - $non_zero));
+  $rows[1] = array(t('User entered value'), $non_empty);
   $rows[2] = array(t('Sum') . ($advanced_stats ? ' (&Sigma;)' : ''), $sum);
   $rows[3] = array($average_title, $average);
 
@@ -561,12 +566,20 @@ function _webform_csv_data_number($component, $export_options, $value) {
  *   None. Calls a form_set_error if the number is not valid.
  */
 function _webform_validate_number($element, &$form_state) {
+  // Trim spaces for basic cleanup.
   $value = trim($element['#value']);
   form_set_value($element, $value, $form_state);
 
   if ($value != '') {
+    // First check that the entered value matches the expected value.
+    if (!webform_number_format_match($value, $element['#point'], $element['#separator'])) {
+      form_error($element, t('%name field value must format numbers as "@example".', array('%name' => $element['#title'], '@example' => webform_number_format(12345.6789, $element['#decimals'], $element['#point'], $element['#separator']))));
+      return;
+    }
+
     // Numeric test.
-    if (is_numeric($value)) {
+    $numeric_value = webform_number_standardize($value, $element['#point']);
+    if (is_numeric($numeric_value)) {
       // Range test.
       if ($element['#min'] != '' && $element['#max'] != '') {
         // Flip minimum and maximum if needed.
@@ -578,25 +591,25 @@ function _webform_validate_number($element, &$form_state) {
           $min = $element['#max'];
           $max = $element['#min'];
         }
-        if ($value > $max || $value < $min) {
-          form_error($element, t('%name field value of @value should be in the range @min to @max.', array('%name' => $element['#title'], '@value' => $value, '@min' => $min, '@max' => $max)));
+        if ($numeric_value > $max || $numeric_value < $min) {
+          form_error($element, t('%name field value of @value should be in the range @min to @max.', array('%name' => $element['#title'], '@value' => $value, '@min' => $element['#min'], '@max' => $element['#max'])));
         }
       }
-      elseif ($element['#max'] != '' && $value > $element['#max']) {
+      elseif ($element['#max'] != '' && $numeric_value > $element['#max']) {
         form_error($element, t('%name field value must be less than @max.', array('%name' => $element['#title'], '@max' => $element['#max'])));
       }
-      elseif ($element['#min'] != '' && $value < $element['#min']) {
+      elseif ($element['#min'] != '' && $numeric_value < $element['#min']) {
         form_error($element, t('%name field value must be greater than @min.', array('%name' => $element['#title'], '@min' => $element['#min'])));
       }
 
       // Integer test.
-      if ($element['#integer'] && !is_int($value * 1)) {
+      if ($element['#integer'] && !is_int($numeric_value * 1)) {
         form_error($element, t('%name field value of @value must be an integer.', array('%name' => $element['#title'], '@value' => $value)));
       }
 
       // Step test.
       $starting_number = $element['#min'] ? $element['#min'] : 0;
-      if ($element['#step'] != 0 && webform_modulo($element['#value'] - $starting_number, $element['#step']) != 0) {
+      if ($element['#step'] != 0 && webform_modulo($numeric_value - $starting_number, $element['#step']) != 0) {
         $samples = array(
           $starting_number,
           $starting_number + ($element['#step'] * 1),
@@ -615,7 +628,20 @@ function _webform_validate_number($element, &$form_state) {
       form_error($element, t('%name field value of @value must be numeric.', array('%name' => $element['#title'], '@value' => $value)));
     }
   }
+}
 
+/**
+ * Implements _webform_submit_component().
+ */
+function _webform_submit_number($component, $value) {
+  // Because _webform_validate_number() ensures the format matches when moving
+  // forward through a form, this should always pass before saving into the
+  // database. When moving backwards in a form, do not adjust the value, since
+  // it has not yet been validated.
+  if (webform_number_format_match($value, $component['extra']['point'], $component['extra']['separator'])) {
+    $value = webform_number_standardize($value, $component['extra']['point']);
+  }
+  return $value;
 }
 
 /**
@@ -721,15 +747,38 @@ function _webform_number_select_options($component) {
 }
 
 /**
- * Apply number format.
+ * Apply number format based on a component and number value.
  */
 function _webform_number_format($component, $value) {
+  return webform_number_format($value, $component['extra']['decimals'], $component['extra']['point'], $component['extra']['separator']);
+}
+
+/**
+ * Validates if a provided number string matches an expected format.
+ *
+ * This function allows the thousands separator to be optional, but decimal
+ * points must be in the right location.
+ *
+ * Based on http://stackoverflow.com/questions/5917082/regular-expression-to-match-numbers-with-or-without-commas-and-decimals-in-text.
+ */
+function webform_number_format_match($value, $point, $separator) {
+  return preg_match('/^(-? ?[1-9](?:\d{0,2})(?:' . ($separator ? (preg_quote($separator, '/') . '?') : '') . '\d{3})*(?:' . preg_quote($point, '/') . '\d*[0-9])?|0?' . preg_quote($point, '/') . '\d*[1-9]|0)$/', $value);
+}
+
+/**
+ * Format a number with thousands separator, decimal point, and decimal places.
+ *
+ * This function is a wrapper around PHP's native number_format(), but allows
+ * the decimal places parameter to be NULL or an empty string, resulting in a
+ * behavior of no change to the decimal places.
+ */
+function webform_number_format($value, $decimals = NULL, $point = '.', $separator = ',') {
   if (!is_numeric($value)) {
     return '';
   }
+
   // If no decimal places are specified, do a best guess length of decimals.
-  $decimals = $component['extra']['decimals'];
-  if ($decimals === '') {
+  if (is_null($decimals) || $decimals === '') {
     // If it's an integer, no decimals needed.
     if (is_int(($value . '') * 1)) {
       $decimals = 0;
@@ -742,7 +791,23 @@ function _webform_number_format($component, $value) {
     }
   }
 
-  return number_format($value, $decimals, $component['extra']['point'], $component['extra']['separator']);
+  return number_format($value, $decimals, $point, $separator);
+}
+
+/**
+ * Given a number, convert it to string compatible with a PHP float.
+ *
+ * @param string $value
+ *   The string value to be standardized into a numeric string.
+ * @param $point
+ *   The point separator between the whole number and the decimals.
+ */
+function webform_number_standardize($value, $point) {
+  // For simplicity, strip everything that's not the decimal point.
+  $value = preg_replace('/[^\-0-9' . preg_quote($point, '/') . ']/', '', $value);
+  // Convert the decimal point to a period.
+  $value = str_replace($point, '.', $value);
+  return $value;
 }
 
 /**
diff --git a/drupal7/sites/all/modules/webform/includes/webform.report.inc b/drupal7/sites/all/modules/webform/includes/webform.report.inc
index 56a29db9..1117b8ff 100644
--- a/drupal7/sites/all/modules/webform/includes/webform.report.inc
+++ b/drupal7/sites/all/modules/webform/includes/webform.report.inc
@@ -730,12 +730,13 @@ function webform_results_export($node, $format = 'delimited', $options = array()
       // Let each component determine its headers.
       if (webform_component_feature($component['type'], 'csv')) {
         $component_header = (array) webform_component_invoke($component['type'], 'csv_headers', $component, $options);
+        // Allow modules to modify the component CSV header.
+        drupal_alter('webform_csv_header', $component_header, $component);
+
+        // Merge component CSV header to overall CSV header
         $header[0] = array_merge($header[0], (array) $component_header[0]);
         $header[1] = array_merge($header[1], (array) $component_header[1]);
         $header[2] = array_merge($header[2], (array) $component_header[2]);
-
-        // Allow modules to modify the CSV header.
-        drupal_alter('webform_csv_header', $component_header, $component);
       }
     }
   }
diff --git a/drupal7/sites/all/modules/webform/includes/webform.submissions.inc b/drupal7/sites/all/modules/webform/includes/webform.submissions.inc
index 433914af..16bb1db6 100644
--- a/drupal7/sites/all/modules/webform/includes/webform.submissions.inc
+++ b/drupal7/sites/all/modules/webform/includes/webform.submissions.inc
@@ -463,7 +463,7 @@ function webform_submission_resend($form, $form_state, $node, $submission) {
     );
 
     $form['actions'] = array('#type' => 'actions');
-    $form['actions']['resend'] = array(
+    $form['actions']['submit'] = array(
       '#type' => 'submit',
       '#value' => t('Resend e-mails'),
     );
diff --git a/drupal7/sites/all/modules/webform/js/select-admin.js b/drupal7/sites/all/modules/webform/js/select-admin.js
index cdc00324..a9830afa 100644
--- a/drupal7/sites/all/modules/webform/js/select-admin.js
+++ b/drupal7/sites/all/modules/webform/js/select-admin.js
@@ -48,7 +48,7 @@ Drupal.webform.selectOptionsLoad = function(result) {
       $('#' + result.elementId).val(result.options).attr('readonly', 'readonly');
     }
     else {
-      $('#' + result.elementId).attr('readonly', '');
+      $('#' + result.elementId).removeAttr('readonly');
     }
   }
 }
diff --git a/drupal7/sites/all/modules/webform/webform.api.php b/drupal7/sites/all/modules/webform/webform.api.php
index 9142ee44..73ec89d1 100644
--- a/drupal7/sites/all/modules/webform/webform.api.php
+++ b/drupal7/sites/all/modules/webform/webform.api.php
@@ -770,10 +770,9 @@ function _webform_submit_component($component, $value) {
  */
 function _webform_delete_component($component, $value) {
   // Delete corresponding files when a submission is deleted.
-  $filedata = unserialize($value['0']);
-  if (isset($filedata['filepath']) && is_file($filedata['filepath'])) {
-    unlink($filedata['filepath']);
-    db_query("DELETE FROM {files} WHERE filepath = '%s'", $filedata['filepath']);
+  if (!empty($value[0]) && ($file = webform_get_file($value[0]))) {
+    file_usage_delete($file, 'webform');
+    file_delete($file);
   }
 }
 
diff --git a/drupal7/sites/all/modules/webform/webform.info b/drupal7/sites/all/modules/webform/webform.info
index c11a5dcc..cc25c6b2 100644
--- a/drupal7/sites/all/modules/webform/webform.info
+++ b/drupal7/sites/all/modules/webform/webform.info
@@ -24,9 +24,9 @@ files[] = tests/permissions.test
 files[] = tests/submission.test
 files[] = tests/webform.test
 
-; Information added by Drupal.org packaging script on 2014-02-12
-version = "7.x-3.20"
+; Information added by Drupal.org packaging script on 2014-10-07
+version = "7.x-3.21"
 core = "7.x"
 project = "webform"
-datestamp = "1392182305"
+datestamp = "1412682050"
 
diff --git a/drupal7/sites/all/modules/webform/webform.module b/drupal7/sites/all/modules/webform/webform.module
index d8066843..2e7f3c8e 100644
--- a/drupal7/sites/all/modules/webform/webform.module
+++ b/drupal7/sites/all/modules/webform/webform.module
@@ -151,21 +151,19 @@ function webform_menu() {
     'type' => MENU_LOCAL_TASK,
   );
   $items['node/%webform_menu/webform/emails/%webform_menu_email'] = array(
-    'title' => 'Edit e-mail settings',
     'load arguments' => array(1),
     'page arguments' => array('webform_email_edit_form', 1, 4),
     'access callback' => 'node_access',
     'access arguments' => array('update', 1),
     'file' => 'includes/webform.emails.inc',
-    'type' => MENU_LOCAL_TASK,
+    'type' => MENU_CALLBACK,
   );
   $items['node/%webform_menu/webform/emails/%webform_menu_email/delete'] = array(
-    'title' => 'Delete e-mail settings',
     'load arguments' => array(1),
     'page arguments' => array('webform_email_delete_form', 1, 4),
     'access callback' => 'node_access',
     'access arguments' => array('update', 1),
-    'type' => MENU_LOCAL_TASK,
+    'type' => MENU_CALLBACK,
   );
 
   // Node component forms.
@@ -1010,6 +1008,7 @@ function webform_webform_submission_render_alter(&$renderable) {
   // are being displayed.
   $node = $renderable['#node'];
   $is_admin = webform_results_access($node);
+  module_load_include('inc', 'webform', 'includes/webform.components');
   if (empty($renderable['#email']) && !$is_admin) {
     // Find and hide the display of all hidden components.
     foreach ($node->webform['components'] as $cid => $component) {
@@ -2086,11 +2085,6 @@ function _webform_client_form_rule_check($node, $component, $page_num, $form_sta
     }
   }
 
-  // Private component?
-  if ($component['extra']['private']) {
-    $show_component = webform_results_access($node);
-  }
-
   return $show_component;
 }
 
@@ -2126,12 +2120,16 @@ function _webform_client_form_rule_check($node, $component, $page_num, $form_sta
  */
 function _webform_client_form_add_component($node, $component, $component_value, &$parent_fieldset, &$form, $form_state, $submission, $format = 'form', $page_num = 0, $filter = TRUE) {
   $cid = $component['cid'];
+  $component_access = empty($component['extra']['private']) || webform_results_access($node);
 
   // Load with submission information if necessary.
   if ($format != 'form') {
     // This component is display only.
     $data = empty($submission->data[$cid]['value']) ? NULL : $submission->data[$cid]['value'];
     if ($display_element = webform_component_invoke($component['type'], 'display', $component, $data, $format)) {
+      // Set access based on the private property.
+      $element['#access'] = $component_access;
+
       // Ensure the component is added as a property.
       $display_element['#webform_component'] = $component;
 
@@ -2159,6 +2157,9 @@ function _webform_client_form_add_component($node, $component, $component_value,
     // Add this user-defined field to the form (with all the values that are always available).
     $data = isset($submission->data[$cid]['value']) ? $submission->data[$cid]['value'] : NULL;
     if ($element = webform_component_invoke($component['type'], 'render', $component, $data, $filter)) {
+      // Set access based on the private property.
+      $element['#access'] = $component_access;
+
       // Ensure the component is added as a property.
       $element['#webform_component'] = $component;
 
@@ -2709,6 +2710,12 @@ function theme_webform_element($variables) {
   }
   $output = '<div class="' . implode(' ', $wrapper_classes) . '" id="webform-component-' . $parents . '">' . "\n";
 
+  // If #title_display is none, set it to invisible instead - none only used if
+  // we have no title at all to use.
+  if ($element['#title_display'] == 'none') {
+    $variables['element']['#title_display'] = 'invisible';
+    $element['#title_display'] = 'invisible';
+  }
   // If #title is not set, we don't display any label or required marker.
   if (!isset($element['#title'])) {
     $element['#title_display'] = 'none';
@@ -3359,6 +3366,7 @@ function webform_format_email_address($address, $name, $node = NULL, $submission
     if ($encode) {
       $name = mime_header_encode($name);
     }
+    $name = trim($name);
     return '"' . $name . '" <' . $address . '>';
   }
   else {
@@ -3769,13 +3777,20 @@ function webform_tt($name, $string, $langcode = NULL, $update = FALSE) {
 function webform_email_html_capable() {
   // TODO: Right now we only support MIME Mail and HTML Mail. Support others
   // if available through a hook?
-  if (module_exists('mimemail')) {
-    $mail_systems = variable_get('mail_system', array('default-system' => 'DefaultMailSystem'));
-    $enable = (!isset($mail_systems['webform']) || $mail_systems['webform'] == 'MimeMailSystem') ? 'MimeMailSystem' : FALSE;
-  }
-  elseif (module_exists('htmlmail')) {
-    $mail_systems = variable_get('mail_system', array('default-system' => 'DefaultMailSystem'));
-    $enable = (!isset($mail_systems['webform']) || $mail_systems['webform'] == 'HTMLMailSystem') ? 'HTMLMailSystem' : FALSE;
+  $supported_html_modules = array(
+    'mimemail' => 'MimeMailSystem',
+    'htmlmail' => 'HTMLMailSystem',
+  );
+  foreach ($supported_html_modules as $mail_module => $mail_system_name) {
+    if (module_exists($mail_module)) {
+      $mail_systems = variable_get('mail_system', array('default-system' => 'DefaultMailSystem'));
+      if (isset($mail_systems['webform'])) {
+        $enable = strpos($mail_systems['webform'], $mail_system_name) !== FALSE ? $mail_systems['webform'] : FALSE;
+      }
+      else {
+        $enable = $mail_system_name;
+      }
+    }
   }
   if (!empty($enable)) {
     // We assume that if a solution exists even if it's not specified we should
